import { world } from "@minecraft/server"

export const api = new class{
    getAllWaypoints(player, dynamics){
        let waypoints = []
        if(!dynamics) return waypoints
        dynamics.forEach(w => { if(w.startsWith(`waypointList${player.dimension.id}`)) waypoints.push(...JSON.parse(player.getDynamicProperty(w))) })
        return waypoints
    }

    saveNewPoint(player, point, waypoints){
        const oldPoints = waypoints.length > 0 ? waypoints : []
        if(waypoints.length != 0) api.resetLastUse(waypoints)
        oldPoints.unshift({id: point, pos: this.aroundPos(player.location), dimension: player.dimension.id, last: true})
        player.onScreenDisplay.setActionBar({translate: "waypoint.warning.createPoint", with: [point]})
        this.saveAllPoints(player, oldPoints)
    }

    saveAllPoints(player, waypoints){
        let list = waypoints
        for(let i = 0; i < Math.floor(waypoints.length / (32767 / 250)) +1; i++){
            let temp = []
            for(let i2 = 0; i2 < Math.floor(32767 / 250); i2++){
                if(!list[0]) break
                temp.push(list.shift())
            }
            player.setDynamicProperty(`waypointList${player.dimension.id}${i}`, JSON.stringify(temp))
        }
    }

    aroundPos(pos){ return {x: Math.floor(pos.x) +0.5, y: Math.floor(pos.y), z: Math.floor(pos.z) +0.5} }

    resetLastUse(waypoints){ waypoints.forEach((w, i) => { if(w.last) w.last = false }) }

    organize(list, type){
        const waypoints = [...list]
        if(type == "a-z"){ return waypoints.sort((a, b) => { return a.id.localeCompare(b.id)}) }
        if(type == "z-a"){ return waypoints.sort((a, b) => { return b.id.localeCompare(a.id)}) }
        if(type == "last"){
            waypoints.unshift(...waypoints.splice(waypoints.findIndex(w => w.last == true), 1))
            return waypoints
        }
    }

    getDistace(player, waypoint){ return `${Math.floor(Math.sqrt((waypoint.x - player.x) ** 2 + (waypoint.z - player.z) ** 2))}` }
}