import { world, system } from "@minecraft/server"

system.runInterval(() => {
    world.getAllPlayers().forEach(player => {
        const currentWaypoint = player.getDynamicProperty(`currentWaypoint${player.dimension.id}`)
        const equippable = player.getComponent("equippable")
        if(equippable.getEquipment("Mainhand")?.typeId == "wp:waypoint_item" || equippable.getEquipment("Offhand")?.typeId == "wp:waypoint_item") if(currentWaypoint){
            if(player.dimension.id == JSON.parse(currentWaypoint).dimension){
                const playerPos = player.location
                const waypointPos = JSON.parse(currentWaypoint).pos
                const playerRot = Math.floor(player.getRotation().y) * (Math.PI / 180)
                const distanceX = waypointPos.x - playerPos.x
                const distanceZ = waypointPos.z - playerPos.z
                const wayAngle = Math.atan2(distanceZ, distanceX)
                const relativeAngle = wayAngle - playerRot
                let degrees = relativeAngle * (180 / Math.PI)
                if(degrees < 0) degrees += 360
                switch(Math.floor(degrees / 22.5)){
                    case 0: player.onScreenDisplay.setActionBar("\uE200"); break
                    case 1: player.onScreenDisplay.setActionBar("\uE201"); break
                    case 2: player.onScreenDisplay.setActionBar("\uE202"); break
                    case 3: player.onScreenDisplay.setActionBar("\uE203"); break
                    case 4: player.onScreenDisplay.setActionBar("\uE204"); break
                    case 5: player.onScreenDisplay.setActionBar("\uE205"); break
                    case 6: player.onScreenDisplay.setActionBar("\uE206"); break
                    case 7: player.onScreenDisplay.setActionBar("\uE207"); break
                    case 8: player.onScreenDisplay.setActionBar("\uE208"); break
                    case 9: player.onScreenDisplay.setActionBar("\uE209"); break
                    case 10: player.onScreenDisplay.setActionBar("\uE210"); break
                    case 11: player.onScreenDisplay.setActionBar("\uE211"); break
                    case 12: player.onScreenDisplay.setActionBar("\uE212"); break
                    case 13: player.onScreenDisplay.setActionBar("\uE213"); break
                    case 14: player.onScreenDisplay.setActionBar("\uE214"); break
                    case 15: player.onScreenDisplay.setActionBar("\uE215"); break
                }
            }
        }
    })
})