import { world, ItemStack } from "@minecraft/server"
import { waypoint } from "./waypoint.js"
import "./locator.js"

world.beforeEvents.worldInitialize.subscribe(data => {
    data.itemComponentRegistry.registerCustomComponent("wp:use", {
        onUse: e => {
            if(e.itemStack.typeId == "wp:waypoint_item") !e.source.isSneaking ? waypoint.selectWaypoint(e.source) : waypoint.configMenu(e.source)
            if(e.itemStack.typeId == "wp:cartography_paper"){
                e.source.getComponent("equippable").setEquipment("Mainhand", new ItemStack("wp:waypoint_item"))
                e.source.playSound("ui.cartography_table.take_result")
            }
        }
    })
})

world.afterEvents.playerSpawn.subscribe(spawn => {
    if(spawn.initialSpawn) if(!spawn.player.getDynamicProperty("waypointConfig")){
        spawn.player.setDynamicProperty("waypointConfig", JSON.stringify({
            organizeType: "a-z",
            showCoordinates: true,
            showDistance: true,
            teleport: false
        }))
    }
})

//world.afterEvents.itemUse.subscribe(use => {
//    if(!use.source.hasTag("dev")) return
//    if(use.itemStack.typeId == "minecraft:stick"){
//        use.source.clearDynamicProperties()
//        use.source.setDynamicProperty("waypointConfig", JSON.stringify({
//            organizeType: "a-z",
//            showCoordinates: true,
//            showDistance: true,
//            teleport: false
//        }))
//    }
//})